#include <stdio.h>
#include <math.h>
#include <setjmp.h>
#include "fktdef.h"

extern double pow();
extern void Pow(), Cmul(), Psym();
extern int  Cdiv();
extern Value F_wert;		/* aktueller Funktionswert */
extern jmp_buf restart;		/* restart-Adresse fuer Fehlerfall */
Value	lv;			/* Wert des letzten berechneten Ausdrucks */
extern short F_ifk;
extern char* F_ep[];
int i, t;
static int yyerrflag;			/* error recovery flag */
typedef union 
{
   Value  val;
   Symbol *sym;
   char   *mfe;
} YYSTYPE;
#ifdef __cplusplus
#  include <stdio.h>
   extern "C" {
     extern void yyerror(char *);
     extern int yylex();
   }
#endif	/* __cplusplus */ 
# define NUMBER 257
# define PVAL 258
# define CONST 259
# define VAR 260
# define UNDEF 261
# define BLTIN 262
# define MFKT 263
# define TABF 264
# define MFKTDEF 265
# define MFKTPAR 266
# define FDATEI 267
# define END 268
# define EXIT 269
# define ASSIGN 270
# define ADDASS 271
# define SUBASS 272
# define MULASS 273
# define DIVASS 274
# define EXPASS 275
# define LSTVAL 276
# define FDEF 277
# define IFTHEN 278
# define LT 279
# define LEQ 280
# define GT 281
# define GEQ 282
# define EQ 283
# define NEQ 284
# define UMINUS 285
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif

/* __YYSCLASS defines the scoping/storage class for global objects
 * that are NOT renamed by the -p option.  By default these names
 * are going to be 'static' so that multi-definition errors
 * will not occur with multiple parsers.
 * If you want (unsupported) access to internal names you need
 * to define this to be null so it implies 'extern' scope.
 * This should not be used in conjunction with -p.
 */
#ifndef __YYSCLASS
# define __YYSCLASS static
#endif
YYSTYPE yylval;
__YYSCLASS YYSTYPE yyval;
typedef int yytabelem;
# define YYERRCODE 256


void assval( v1, t, v2 )
Value *v1, *v2;
short t;
{
   short i;

   if ( t == 1 )
      v1->u.s = v2->u.s;
   else
      for ( i = 0; i < t; i++ )
	 v1->u.v[i] = v2->u.v[i];

   v1->type = t;
}

/* Retten der globalen Parser-Daten bei Rekursion */

#define MAXRD 20
static int * yy_int[MAXRD], yy_actrd = -1;
static YYSTYPE * yy_typ[MAXRD];
extern int yynerrs;
extern YYSTYPE yyv[];

yypush(sdepth)
int   sdepth;
{
   if ( yy_actrd < MAXRD )
   {
      register short i;
      register int *pint;
      register YYSTYPE *ptyp;

      ++yy_actrd;
      pint = yy_int[yy_actrd] = (int *) emalloc( sizeof(int)*4 );
      ptyp = yy_typ[yy_actrd] = (YYSTYPE *) emalloc( sizeof(YYSTYPE)*(2+sdepth));

      *pint = yychar;  *(++pint) = yynerrs;  *(++pint) = (int) yyerrflag;
      *(++pint) = sdepth;
      *ptyp = yyval;   *(++ptyp) = yylval;

      for ( i=0; i < sdepth; i++ )
	 *(++ptyp) = yyv[i];
   }
   else
      execerror( "!! Max. Verschachtelungsstiefe ueberschritten", (char *)0);
}

yypop()
{
   if ( yy_actrd >= 0 )
   {
      register short i;
      register int *pint;
      register YYSTYPE *ptyp;
      int sdepth;

      pint = yy_int[yy_actrd];
      ptyp = yy_typ[yy_actrd];

      yychar = *pint;  yynerrs = *(++pint);  yyerrflag = (short) *(++pint);
      sdepth = *(++pint);
      yyval  = *ptyp;  yylval  = *(++ptyp);

      for ( i=0; i < sdepth; i++ )
	yyv[i]  = *(++ptyp);

      free(yy_typ[yy_actrd]);
      free(yy_int[yy_actrd]);
      yy_typ[yy_actrd] = NULL;
      yy_int[yy_actrd] = NULL;
      --yy_actrd;
   }
}

yyerror( s )
char *s;
{
   warning( s, NULL );
}

warning( s, t )
char *s, *t;
{
   fprintf( stderr, "Fkt: %s", s );

   if ( t )
      fprintf( stderr, " - %s", t );

   fprintf( stderr, "\n" );
   longjmp(restart,0);
}

yywrap()
{
   return(1);
}
__YYSCLASS yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 56
# define YYLAST 374
__YYSCLASS yytabelem yyact[]={

    67,    26,    24,    31,    25,    29,    27,    26,    24,    64,
    25,   134,    27,    32,    33,    34,    35,    36,    37,   142,
    38,    21,    22,    19,    20,    17,    18,   132,    26,    24,
   117,    25,   115,    27,    12,    41,    99,    97,    65,    13,
    57,   141,    12,   133,   131,   116,   114,    13,    98,    96,
   125,   123,    28,    28,   138,    26,    24,   137,    25,    28,
    27,    26,    50,    41,    49,   107,    27,    13,     5,   128,
    26,    24,   129,    25,    70,    27,     3,    89,    48,   105,
    28,    42,    46,    82,    80,    51,    40,    47,    44,     2,
     1,     0,     0,    52,    53,    54,    55,    56,     0,   124,
   122,    58,    59,    60,    61,    62,    63,    28,     0,     0,
    66,     0,     0,    28,   106,    72,    68,    69,     0,    71,
     0,     0,    28,   126,    26,    24,   127,    25,   104,    27,
     0,     0,    81,    79,     0,     0,     0,     0,   121,    88,
     0,     0,    90,    91,    92,    93,    94,    95,   110,    26,
    24,   111,    25,   100,    27,   101,   102,   108,    26,    24,
   109,    25,     0,    27,    85,    26,    24,    86,    25,     0,
    27,     0,   113,     0,     0,     0,    28,    30,   118,     0,
   119,   120,    32,    33,    34,    35,    36,    37,     0,    38,
     0,     0,     0,     0,     0,     0,   135,     0,   136,     0,
     0,    28,     0,     0,     0,     0,     0,     0,     0,     0,
    28,    26,    24,   112,    25,     0,    27,    28,    83,    26,
    24,    84,    25,     0,    27,     0,     0,     0,     0,     0,
   140,    26,    24,     0,    25,     0,    27,     0,    73,    74,
    75,    76,    77,    78,    73,    74,    75,    76,    77,    78,
     4,     9,     6,    10,     7,    23,    14,     8,    15,     9,
    39,    10,    43,    28,    14,    45,    15,     0,     0,     0,
    11,    28,    16,     0,     0,     0,     0,     0,    11,     9,
    16,    10,    43,    28,    14,    45,    15,   139,    26,    24,
     0,    25,     0,    27,     0,   130,    26,    24,    11,    25,
    16,    27,    26,    24,   103,    25,     0,    27,    26,    24,
    87,    25,     0,    27,    67,    26,    24,     0,    25,     0,
    27,    26,    24,     0,    25,     0,    27,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    28,     0,     0,     0,     0,     0,     0,     0,    28,     0,
     0,     0,     0,     0,    28,     0,     0,     0,     0,     0,
    28,     0,     0,     0,     0,     0,     0,    28,     0,     0,
     0,     0,     0,    28 };
__YYSCLASS yytabelem yypact[]={

    -6, -3000,  -243,  -245,  -247,   -14,  -264,   -88,    -5, -3000,
 -3000, -3000,     2,     2,    47,    38,    22, -3000, -3000, -3000,
 -3000, -3000, -3000, -3000,     2,     2,     2,     2,     2, -3000,
 -3000,  -226,     2,     2,     2,     2,     2,     2,  -258, -3000,
  -228,     2,   273,  -257, -3000,    23,   -42,     2,     2,    30,
    22,   -35,    19,    19,   -42,   -42,   -42,    40,   279,   279,
   279,   279,   279,   279, -3000,    39,   177, -3000,   123,   266,
     2,   -41,    36,     2,     2,     2,     2,     2,     2,  -216,
  -229,  -217,  -230, -3000,     2, -3000,     2,     2,   260, -3000,
   279,   279,   279,   279,   279,   279, -3000,    35, -3000,    21,
   116,   107,   169,     2,  -219,  -234,  -220,  -236, -3000,     2,
 -3000,     2,     2,    13, -3000,     7, -3000,     6,    82,    28,
   254, -3000,  -221,  -239,  -222,  -255, -3000,     2, -3000,     2,
 -3000, -3000,   -36, -3000,   -39,   246,   189,  -224,  -246, -3000,
 -3000, -3000, -3000 };
__YYSCLASS yytabelem yypgo[]={

     0,    68,    88,    64,    90,    76 };
__YYSCLASS yytabelem yyr1[]={

     0,     4,     4,     4,     4,     4,     4,     4,     4,     5,
     5,     5,     5,     5,     5,     5,     5,     5,     5,     2,
     2,     2,     2,     2,     2,     2,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
     3,     3,     3,     3,     3,     3 };
__YYSCLASS yytabelem yyr2[]={

     0,     4,     4,     4,     5,     4,     5,     5,     5,     5,
     5,    11,    11,    15,    15,    19,    19,    23,    23,     7,
     7,     7,     7,     7,     7,     7,     2,     3,     3,     3,
     2,     7,     5,     3,     9,    13,    17,    21,     9,    13,
    17,    21,    17,     7,     7,     7,     7,     7,    15,     7,
     7,     7,     7,     7,     7,     7 };
__YYSCLASS yytabelem yychk[]={

 -3000,    -4,    -2,    -5,   256,    -1,   258,   260,   263,   257,
   259,   276,    40,    45,   262,   264,   278,   268,   269,   268,
   269,   268,   269,   269,    43,    45,    42,    47,    94,   269,
   265,    91,   270,   271,   272,   273,   274,   275,   277,   265,
    91,    40,    -1,   260,    -2,   263,    -1,    40,    40,    -3,
    40,    -1,    -1,    -1,    -1,    -1,    -1,   266,    -1,    -1,
    -1,    -1,    -1,    -1,   267,   266,    -1,    41,    -1,    -1,
    44,    -1,    -3,   279,   280,   281,   282,   283,   284,    93,
    44,    93,    44,    41,    44,    41,    44,    44,    -1,    41,
    -1,    -1,    -1,    -1,    -1,    -1,   265,   266,   265,   266,
    -1,    -1,    -1,    44,    93,    44,    93,    44,    41,    44,
    41,    44,    44,    -1,   265,   266,   265,   266,    -1,    -1,
    -1,   125,    93,    44,    93,    44,    41,    44,    41,    44,
    41,   265,   266,   265,   266,    -1,    -1,    93,    93,    41,
    41,   265,   265 };
__YYSCLASS yytabelem yydef[]={

     0,    -2,    30,     0,     0,     0,     0,    29,    33,    26,
    27,    28,     0,     0,     0,     0,     0,     1,     2,     3,
     4,     5,     6,     7,     0,     0,     0,     0,     0,     8,
     9,     0,     0,     0,     0,     0,     0,     0,     0,    10,
     0,     0,     0,    29,    30,    33,    32,     0,     0,     0,
     0,     0,    43,    44,    45,    46,    47,     0,    19,    20,
    21,    22,    23,    24,    25,     0,     0,    31,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    34,     0,    38,     0,     0,     0,    49,
    50,    51,    52,    53,    54,    55,    11,     0,    12,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    35,     0,
    39,     0,     0,     0,    13,     0,    14,     0,     0,     0,
     0,    48,     0,     0,     0,     0,    36,     0,    40,     0,
    42,    15,     0,    16,     0,     0,     0,     0,     0,    37,
    41,    17,    18 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

__YYSCLASS yytoktype yytoks[] =
{
	"NUMBER",	257,
	"PVAL",	258,
	"CONST",	259,
	"VAR",	260,
	"UNDEF",	261,
	"BLTIN",	262,
	"MFKT",	263,
	"TABF",	264,
	"MFKTDEF",	265,
	"MFKTPAR",	266,
	"FDATEI",	267,
	"END",	268,
	"EXIT",	269,
	"ASSIGN",	270,
	"ADDASS",	271,
	"SUBASS",	272,
	"MULASS",	273,
	"DIVASS",	274,
	"EXPASS",	275,
	"LSTVAL",	276,
	"FDEF",	277,
	"IFTHEN",	278,
	"LT",	279,
	"LEQ",	280,
	"GT",	281,
	"GEQ",	282,
	"EQ",	283,
	"NEQ",	284,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"UMINUS",	285,
	"^",	94,
	"-unknown-",	-1	/* ends search */
};

__YYSCLASS char * yyreds[] =
{
	"-no such reduction-",
	"list : asgn END",
	"list : asgn EXIT",
	"list : mfktd END",
	"list : mfktd EXIT",
	"list : error END",
	"list : error EXIT",
	"list : expr EXIT",
	"list : PVAL EXIT",
	"mfktd : VAR MFKTDEF",
	"mfktd : MFKT MFKTDEF",
	"mfktd : VAR '[' MFKTPAR ']' MFKTDEF",
	"mfktd : MFKT '[' MFKTPAR ']' MFKTDEF",
	"mfktd : VAR '[' MFKTPAR ',' MFKTPAR ']' MFKTDEF",
	"mfktd : MFKT '[' MFKTPAR ',' MFKTPAR ']' MFKTDEF",
	"mfktd : VAR '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF",
	"mfktd : MFKT '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF",
	"mfktd : VAR '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF",
	"mfktd : MFKT '[' MFKTPAR ',' MFKTPAR ',' MFKTPAR ',' MFKTPAR ']' MFKTDEF",
	"asgn : VAR ASSIGN expr",
	"asgn : VAR ADDASS expr",
	"asgn : VAR SUBASS expr",
	"asgn : VAR MULASS expr",
	"asgn : VAR DIVASS expr",
	"asgn : VAR EXPASS expr",
	"asgn : VAR FDEF FDATEI",
	"expr : NUMBER",
	"expr : CONST",
	"expr : LSTVAL",
	"expr : VAR",
	"expr : asgn",
	"expr : '(' expr ')'",
	"expr : '-' expr",
	"expr : MFKT",
	"expr : MFKT '(' expr ')'",
	"expr : MFKT '(' expr ',' expr ')'",
	"expr : MFKT '(' expr ',' expr ',' expr ')'",
	"expr : MFKT '(' expr ',' expr ',' expr ',' expr ')'",
	"expr : BLTIN '(' expr ')'",
	"expr : BLTIN '(' expr ',' expr ')'",
	"expr : BLTIN '(' expr ',' expr ',' expr ')'",
	"expr : BLTIN '(' expr ',' expr ',' expr ',' expr ')'",
	"expr : TABF '(' expr ',' expr ',' expr ')'",
	"expr : expr '+' expr",
	"expr : expr '-' expr",
	"expr : expr '*' expr",
	"expr : expr '/' expr",
	"expr : expr '^' expr",
	"expr : IFTHEN logexpr ',' expr ',' expr '}'",
	"logexpr : '(' logexpr ')'",
	"logexpr : expr LT expr",
	"logexpr : expr LEQ expr",
	"logexpr : expr GT expr",
	"logexpr : expr GEQ expr",
	"logexpr : expr EQ expr",
	"logexpr : expr NEQ expr",
};
#endif /* YYDEBUG */
#define YYFLAG  (-3000)
/* @(#) $Revision: 70.7 $ */    

/*
** Skeleton parser driver for yacc output
*/

#if defined(NLS) && !defined(NL_SETN)
#include <msgbuf.h>
#endif

#ifndef nl_msg
#define nl_msg(i,s) (s)
#endif

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab

#ifndef __RUNTIME_YYMAXDEPTH
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#else
#define YYACCEPT	{free_stacks(); return(0);}
#define YYABORT		{free_stacks(); return(1);}
#endif

#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( (nl_msg(30001,"syntax error - cannot backup")) );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
/* define for YYFLAG now generated by yacc program. */
/*#define YYFLAG		(FLAGVAL)*/

/*
** global variables used by the parser
*/
# ifndef __RUNTIME_YYMAXDEPTH
__YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];	/* value stack */
__YYSCLASS int yys[ YYMAXDEPTH ];		/* state stack */
# else
__YYSCLASS YYSTYPE *yyv;			/* pointer to malloc'ed value stack */
__YYSCLASS int *yys;			/* pointer to malloc'ed stack stack */

#if defined(__STDC__) || defined (__cplusplus)
#include <stdlib.h>
#else
	extern char *malloc();
	extern char *realloc();
	extern void free();
#endif /* __STDC__ or __cplusplus */


static int allocate_stacks(); 
static void free_stacks();
# ifndef YYINCREMENT
# define YYINCREMENT (YYMAXDEPTH/2) + 10
# endif
# endif	/* __RUNTIME_YYMAXDEPTH */
long  yymaxdepth = YYMAXDEPTH;

__YYSCLASS YYSTYPE *yypv;			/* top of value stack */
__YYSCLASS int *yyps;			/* top of state stack */

__YYSCLASS int yystate;			/* current state */
__YYSCLASS int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
__YYSCLASS int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
# ifdef __RUNTIME_YYMAXDEPTH
	if (allocate_stacks()) YYABORT;
# endif
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
# ifndef __RUNTIME_YYMAXDEPTH
			yyerror( (nl_msg(30002,"yacc stack overflow")) );
			YYABORT;
# else
			/* save old stack bases to recalculate pointers */
			YYSTYPE * yyv_old = yyv;
			int * yys_old = yys;
			yymaxdepth += YYINCREMENT;
			yys = (int *) realloc(yys, yymaxdepth * sizeof(int));
			yyv = (YYSTYPE *) realloc(yyv, yymaxdepth * sizeof(YYSTYPE));
			if (yys==0 || yyv==0) {
			    yyerror( (nl_msg(30002,"yacc stack overflow")) );
			    YYABORT;
			    }
			/* Reset pointers into stack */
			yy_ps = (yy_ps - yys_old) + yys;
			yyps = (yyps - yys_old) + yys;
			yy_pv = (yy_pv - yyv_old) + yyv;
			yypv = (yypv - yyv_old) + yyv;
# endif

		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( (nl_msg(30003,"syntax error")) );
				yynerrs++;
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 4:{  YYACCEPT; } break;
case 6:{  yyerrok;
	       execerror("!! Syntax-Fehler !", NULL ); } break;
case 7:{ 
	       if ((F_wert.type = yypvt[-1].val.type) == 1 )
		  F_wert.u.s = yypvt[-1].val.u.s;  
	       else for ( i = 0; i < yypvt[-1].val.type; i++ )
		  F_wert.u.v[i] = yypvt[-1].val.u.v[i];


	       YYACCEPT; 
	    } break;
case 8:{
	       if ( yypvt[-1].val.type == -1 )
		  for ( i = 0; i <= MDIM; i++ )
		     Psym(i);
	       else if ( yypvt[-1].val.type >= 0 && yypvt[-1].val.type <= MDIM )
		  Psym(yypvt[-1].val.type);

	       YYACCEPT;
	    } break;
case 9:{
	       yypvt[-1].sym->class = MFKT;
	       yypvt[-1].sym->V.type = 0;
	       yypvt[-1].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 10:{
	       if ( yypvt[-1].sym->V.u.mf.expr )
		  free(yypvt[-1].sym->V.u.mf.expr);

	       yypvt[-1].sym->V.type = 0;
	       yypvt[-1].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 11:{
	       yypvt[-4].sym->class = MFKT;
	       yypvt[-4].sym->V.type = 1;
	       yypvt[-4].sym->V.u.mf.pnam[0] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-4].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 12:{
	       if ( & yypvt[-4].sym->V.u.mf.expr )
		  free(yypvt[-4].sym->V.u.mf.expr);

	       yypvt[-4].sym->V.type = 1;
	       yypvt[-4].sym->V.u.mf.pnam[0] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-4].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 13:{
	       yypvt[-6].sym->class = MFKT;
	       yypvt[-6].sym->V.type = 2;
	       yypvt[-6].sym->V.u.mf.pnam[0] = *yypvt[-4].mfe;  free(yypvt[-4].mfe);
	       yypvt[-6].sym->V.u.mf.pnam[1] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-6].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 14:{
	       if ( yypvt[-6].sym->V.u.mf.expr )
		  free(yypvt[-6].sym->V.u.mf.expr);

	       yypvt[-6].sym->V.type = 2;
	       yypvt[-6].sym->V.u.mf.pnam[0] = *yypvt[-4].mfe;  free(yypvt[-4].mfe);
	       yypvt[-6].sym->V.u.mf.pnam[1] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-6].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 15:{
	       yypvt[-8].sym->class = MFKT;
	       yypvt[-8].sym->V.type = 3;
	       yypvt[-8].sym->V.u.mf.pnam[0] = *yypvt[-6].mfe;  free(yypvt[-6].mfe);
	       yypvt[-8].sym->V.u.mf.pnam[1] = *yypvt[-4].mfe;  free(yypvt[-4].mfe);
	       yypvt[-8].sym->V.u.mf.pnam[2] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-8].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 16:{
	       if ( yypvt[-8].sym->V.u.mf.expr )
		  free(yypvt[-8].sym->V.u.mf.expr);

	       yypvt[-8].sym->V.type = 3;
	       yypvt[-8].sym->V.u.mf.pnam[0] = *yypvt[-6].mfe;  free(yypvt[-6].mfe);
	       yypvt[-8].sym->V.u.mf.pnam[1] = *yypvt[-4].mfe;  free(yypvt[-4].mfe);
	       yypvt[-8].sym->V.u.mf.pnam[2] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-8].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 17:{
	       yypvt[-10].sym->class = MFKT;
	       yypvt[-10].sym->V.type = 4;
	       yypvt[-10].sym->V.u.mf.pnam[0] = *yypvt[-8].mfe;  free(yypvt[-8].mfe);
	       yypvt[-10].sym->V.u.mf.pnam[1] = *yypvt[-6].mfe;  free(yypvt[-6].mfe);
	       yypvt[-10].sym->V.u.mf.pnam[2] = *yypvt[-4].mfe;  free(yypvt[-4].mfe);
	       yypvt[-10].sym->V.u.mf.pnam[3] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-10].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 18:{
	       if ( yypvt[-10].sym->V.u.mf.expr )
		  free(yypvt[-10].sym->V.u.mf.expr);

	       yypvt[-10].sym->V.type = 4;
	       yypvt[-10].sym->V.u.mf.pnam[0] = *yypvt[-8].mfe;  free(yypvt[-8].mfe);
	       yypvt[-10].sym->V.u.mf.pnam[1] = *yypvt[-6].mfe;  free(yypvt[-6].mfe);
	       yypvt[-10].sym->V.u.mf.pnam[2] = *yypvt[-4].mfe;  free(yypvt[-4].mfe);
	       yypvt[-10].sym->V.u.mf.pnam[3] = *yypvt[-2].mfe;  free(yypvt[-2].mfe);
	       yypvt[-10].sym->V.u.mf.expr = yypvt[-0].mfe;
	    } break;
case 19:{
	       yypvt[-2].sym->V.type = yyval.val.type = yypvt[-0].val.type;

	       switch( yypvt[-0].val.type )
	       {
	       case 1:
		  yypvt[-2].sym->V.u.s  = yyval.val.u.s  = yypvt[-0].val.u.s;
		  break;
	       case 2: 
		  for ( i = 0; i < yypvt[-2].sym->V.type; i++ )
		     yypvt[-2].sym->V.u.v[i] = yyval.val.u.v[i] = yypvt[-0].val.u.v[i];

		  break;
	       }

	       if ( yypvt[-2].sym->class == UNDEF )
		  yypvt[-2].sym->class = VAR;
	    } break;
case 20:{
	       if ( yypvt[-2].sym->class == UNDEF )
		  execerror( "undefinierte Variable", yypvt[-2].sym->name );

	       if ( yypvt[-2].sym->V.type == yypvt[-0].val.type )
	       {
		  if (( t = yyval.val.type = yypvt[-2].sym->V.type ) <= MDIM )
		     for ( i = 0; i < t; i++ )
			yyval.val.u.v[i] = yypvt[-2].sym->V.u.v[i] += yypvt[-0].val.u.v[i];
		  else
		     execerror( "Operation unzulaessig", NULL );
	       }
	       else if ( yypvt[-2].sym->V.type == 2 && yypvt[-0].val.type == 1 )
	       {
		  yyval.val.u.v[0] = yypvt[-2].sym->V.u.v[0] += yypvt[-0].val.u.s;
		  yyval.val.u.v[1] = yypvt[-2].sym->V.u.v[1];
		  yyval.val.type   = yypvt[-2].sym->V.type;
	       }
	       else
		  execerror( "unzulaessige Typkombination", NULL );
	    } break;
case 21:{
	       if ( yypvt[-2].sym->class == UNDEF )
		  execerror( "undefinierte Variable", yypvt[-2].sym->name );

	       if ( yypvt[-2].sym->V.type == yypvt[-0].val.type )
	       {
		  if (( t = yyval.val.type = yypvt[-2].sym->V.type ) <= MDIM )
		     for ( i = 0; i < t; i++ )
			yyval.val.u.v[i] = yypvt[-2].sym->V.u.v[i] -= yypvt[-0].val.u.v[i];
		  else
		     execerror( "Operation unzulaessig", NULL );
	       }
	       else if ( yypvt[-2].sym->V.type == 2 && yypvt[-0].val.type == 1 )
	       {
		  yyval.val.u.v[0] = yypvt[-2].sym->V.u.v[0] -= yypvt[-0].val.u.s;
		  yyval.val.u.v[1] = yypvt[-2].sym->V.u.v[1];
		  yyval.val.type   = yypvt[-2].sym->V.type;
	       }
	       else
		  execerror( "unzulaessige Typkombination", NULL );
	    } break;
case 22:{
	       if ( yypvt[-2].sym->class == UNDEF )
		  execerror( "undefinierte Variable", yypvt[-2].sym->name );

	       if ( yypvt[-2].sym->V.type == yypvt[-0].val.type )
	       {
		  switch ( yypvt[-2].sym->V.type )
		  {
		  case 1:
		     yypvt[-2].sym->V.u.s *= yypvt[-0].val.u.s;
		     break;

		  case 2:
		     Cmul( yypvt[-2].sym->V.u.v, yypvt[-0].val.u.v, yypvt[-2].sym->V.u.v );
		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }
	       else 
	       {
		  switch( yypvt[-0].val.type )
		  {
		  case 1:
		     if (( t = yypvt[-2].sym->V.type ) == 2 )
			for ( i = 0; i < t; i++ )
			   yypvt[-2].sym->V.u.v[i] *= yypvt[-0].val.u.s;
		     else
			execerror( "Operation unzulaessig", NULL );

		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }

	       assval( &yyval.val, yypvt[-2].sym->V.type, &yypvt[-2].sym->V );
	    } break;
case 23:{
	       if ( yypvt[-2].sym->class == UNDEF )
		  execerror( "undefinierte Variable", yypvt[-2].sym->name );

	       if ( yypvt[-2].sym->V.type == yypvt[-0].val.type )
	       {
		  switch ( yypvt[-2].sym->V.type )
		  {
		  case 1:
		     yypvt[-2].sym->V.u.s /= yypvt[-0].val.u.s;
		     break;

		  case 2:
		     if ( !Cdiv( yypvt[-2].sym->V.u.v, yypvt[-0].val.u.v, yypvt[-2].sym->V.u.v ))
			execerror( "Division durch 0", NULL );

		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }
	       else 
	       {
		  switch( yypvt[-0].val.type )
		  {
		  case 1:
		     if (( t = yypvt[-2].sym->V.type ) == 2 )
			if ( abs(yypvt[-0].val.u.s) > EPSD )
			   for ( i = 0; i < t; i++ )
			      yypvt[-2].sym->V.u.v[i] /= yypvt[-0].val.u.s;
			else
			   execerror( "Division durch 0", NULL );
		     else
			execerror( "Operation unzulaessig", NULL );

		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
		  }
	       }

	       assval( &yyval.val, yypvt[-2].sym->V.type, &yypvt[-2].sym->V );
	    } break;
case 24:{
	       if ( yypvt[-2].sym->class == UNDEF )
		  execerror( "undefinierte Variable", yypvt[-2].sym->name );

	       if ( yypvt[-2].sym->V.type == yypvt[-0].val.type && yypvt[-2].sym->V.type <= MDIM )
	       {
		  yyval.val.type = 2;
		  Pow(&yyval.val,&yypvt[-2].sym->V,&yypvt[-0].val);
		  assval(&yypvt[-2].sym->V,yyval.val.type,&yyval.val);
	       }
	       else
		  execerror( "Operation unzulaessig", NULL );
	    } break;
case 25:{
	       F_tdef( yypvt[-2].sym, yypvt[-0].mfe );    /* Definition einer tabellierten Funktion */
	    } break;
case 27:{
	       assval( &yyval.val, yypvt[-0].sym->V.type, &yypvt[-0].sym->V );
	    } break;
case 28:{
	       assval(&yyval.val,lv.type,&lv);
	    } break;
case 29:{
	       if ( yypvt[-0].sym->class == UNDEF )
		  execerror( "undefinierte Variable", yypvt[-0].sym->name );

	       assval( &yyval.val, yypvt[-0].sym->V.type, &yypvt[-0].sym->V );
	    } break;
case 31:{
	       assval( &yyval.val, yypvt[-1].val.type, &yypvt[-1].val );
	    } break;
case 32:{
	       t = ( yyval.val.type = yypvt[-0].val.type );

	       for ( i = 0; i < t; i++ )
		  yyval.val.u.v[i] = -yypvt[-0].val.u.v[i];
	    } break;
case 33:{
	       F_ep[++F_ifk] = yypvt[-0].sym->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if ((yyval.val.type = F_wert.type) == 1 )
		  yyval.val.u.s = F_wert.u.s;  
	       else for ( i = 0; i < yyval.val.type; i++ )
		  yyval.val.u.v[i] = F_wert.u.v[i];
	    } break;
case 34:{
	       char p1;
	       Psymbol *ps;

	       p1 = yypvt[-3].sym->V.u.mf.pnam[0];
	       ps = Pinstall(p1, &yypvt[-1].val);
	       F_ep[++F_ifk] = yypvt[-3].sym->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if ((yyval.val.type = F_wert.type) == 1 )
		  yyval.val.u.s = F_wert.u.s;  
	       else for ( i = 0; i < yyval.val.type; i++ )
		  yyval.val.u.v[i] = F_wert.u.v[i];

	       Deinstall(p1);
	    } break;
case 35:{
	       char p1[2];
	       Psymbol *ps;

	       for ( i = 0; i < 2; i++ )
		  p1[i] = yypvt[-5].sym->V.u.mf.pnam[i];

	       ps = Pinstall(p1[0], &yypvt[-3].val);
	       ps = Pinstall(p1[1], &yypvt[-1].val);
	       F_ep[++F_ifk] = yypvt[-5].sym->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if ((yyval.val.type = F_wert.type) == 1 )
		  yyval.val.u.s = F_wert.u.s;  
	       else for ( i = 0; i < yyval.val.type; i++ )
		  yyval.val.u.v[i] = F_wert.u.v[i];

	       for ( i = 0; i < 2; i++ )
		  Deinstall(p1[i]);
	    } break;
case 36:{
	       char p1[3];
	       Psymbol *ps;

	       for ( i = 0; i < 3; i++ )
		  p1[i] = yypvt[-7].sym->V.u.mf.pnam[i];

	       ps = Pinstall(p1[0], &yypvt[-5].val);
	       ps = Pinstall(p1[1], &yypvt[-3].val);
	       ps = Pinstall(p1[2], &yypvt[-1].val);
	       F_ep[++F_ifk] = yypvt[-7].sym->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if ((yyval.val.type = F_wert.type) == 1 )
		  yyval.val.u.s = F_wert.u.s;  
	       else for ( i = 0; i < yyval.val.type; i++ )
		  yyval.val.u.v[i] = F_wert.u.v[i];

	       for ( i = 0; i < 3; i++ )
		  Deinstall(p1[i]);
	    } break;
case 37:{
	       char p1[4];
	       Psymbol *ps;

	       for ( i = 0; i < 4; i++ )
		  p1[i] = yypvt[-9].sym->V.u.mf.pnam[i];

	       ps = Pinstall(p1[0], &yypvt[-7].val);
	       ps = Pinstall(p1[1], &yypvt[-5].val);
	       ps = Pinstall(p1[2], &yypvt[-3].val);
	       ps = Pinstall(p1[3], &yypvt[-1].val);
	       F_ep[++F_ifk] = yypvt[-9].sym->V.u.mf.expr;
	       yypush(yypv-&yyv[-1]);
	       i = yyparse();
	       yypop();
	       --F_ifk;

	       if ((yyval.val.type = F_wert.type) == 1 )
		  yyval.val.u.s = F_wert.u.s;  
	       else for ( i = 0; i < yyval.val.type; i++ )
		  yyval.val.u.v[i] = F_wert.u.v[i];

	       for ( i = 0; i < 4; i++ )
		  Deinstall(p1[i]);
	    } break;
case 38:{
	       if ((yyval.val.type = yypvt[-3].sym->V.type) == MULTPAR )
		  yyval.val.type = 1;
	       else if ( yyval.val.type != 1 )
		  execerror( yypvt[-3].sym->name, "unzulaessige Parameteranzahl" );

	       (*(yypvt[-3].sym->V.u.f))( &yyval.val, &yypvt[-1].val );
	    } break;
case 39:{
	       if ((yyval.val.type = yypvt[-5].sym->V.type) == MULTPAR )
		  yyval.val.type = 2;
	       else if ( yyval.val.type != 2 )
		  execerror( yypvt[-5].sym->name, "unzulaessige Parameteranzahl" );

	       (*(yypvt[-5].sym->V.u.f))( &yyval.val, &yypvt[-3].val, &yypvt[-1].val );
	    } break;
case 40:{
	       if ((yyval.val.type = yypvt[-7].sym->V.type) == MULTPAR )
		  yyval.val.type = 3;
	       else if ( yyval.val.type != 3 )
		  execerror( yypvt[-7].sym->name, "unzulaessige Parameteranzahl" );

	       (*(yypvt[-7].sym->V.u.f))( &yyval.val, &yypvt[-5].val, &yypvt[-3].val, &yypvt[-1].val );
	    } break;
case 41:{
	       if ((yyval.val.type = yypvt[-9].sym->V.type) == MULTPAR )
		  yyval.val.type = 4;
	       else if ( yyval.val.type != 4 )
		  execerror( yypvt[-9].sym->name, "unzulaessige Parameteranzahl" );

	       (*(yypvt[-9].sym->V.u.f))( &yyval.val, &yypvt[-7].val, &yypvt[-5].val, &yypvt[-3].val, &yypvt[-1].val );
	    } break;
case 42:{
	       F_tval( &yyval.val, yypvt[-7].sym, &yypvt[-5].val, &yypvt[-3].val, &yypvt[-1].val );  /* Auswerten einer tabellierten Funktion */
	    } break;
case 43:{
	       if ( yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  switch ( t = yyval.val.type = yypvt[-2].val.type )
		  {
		  case 1:
		     yyval.val.u.s = yypvt[-2].val.u.s + yypvt[-0].val.u.s;
		     break;
		  case 2:
		     for ( i = 0; i < t; i++ )
			yyval.val.u.v[i] = yypvt[-2].val.u.v[i] + yypvt[-0].val.u.v[i];

		     break;
		  default:
		     execerror( "undefinierte Operation", NULL );
		  }
	       }
	       else
	       {
		  Value v1, v2;
		  short t1, t2;

		  if ( yypvt[-2].val.type < yypvt[-0].val.type )
		  {
		     t1 = yypvt[-2].val.type;  t2 = yypvt[-0].val.type;
		     assval( &v1, t1, &yypvt[-2].val );
		     assval( &v2, t2, &yypvt[-0].val );
		  }
		  else
		  {
		     t1 = yypvt[-0].val.type;  t2 = yypvt[-2].val.type;
		     assval( &v1, t1, &yypvt[-0].val );
		     assval( &v2, t2, &yypvt[-2].val );
		  }

		  switch ( t1 )
		  {
		  case 1:
		     if ( t2 == 2 )
		     {
			yyval.val.u.v[0] = v1.u.s + v2.u.v[0];
			yyval.val.u.v[1] = v2.u.v[1];
			yyval.val.type   = t2;
		     }
		     else
			execerror( "unzulaessige Typkombination", NULL );

		     break;

		  default:
		     execerror( "unzulaessige Typkombination", NULL );
		  }
	       }
	    } break;
case 44:{
	       if ( yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  switch ( t = yyval.val.type = yypvt[-2].val.type )
		  {
		  case 1:
		     yyval.val.u.s = yypvt[-2].val.u.s - yypvt[-0].val.u.s;
		     break;
		  case 2:
		     for ( i = 0; i < t; i++ )
			yyval.val.u.v[i] = yypvt[-2].val.u.v[i] - yypvt[-0].val.u.v[i];

		     break;
		  default:
		     execerror( "undefinierte Operation", NULL );
		  }
	       }
	       else
	       {
		  Value v1, v2;
		  short t1, t2;

		  if ( yypvt[-2].val.type < yypvt[-0].val.type )
		  {
		     t1 = yypvt[-2].val.type;  t2 = yypvt[-0].val.type;
		     assval( &v1, t1, &yypvt[-2].val );
		     assval( &v2, t2, &yypvt[-0].val );
		  }
		  else
		  {
		     t1 = yypvt[-0].val.type;  t2 = yypvt[-2].val.type;
		     assval( &v1, t1, &yypvt[-0].val );
		     assval( &v2, t2, &yypvt[-2].val );
		  }

		  switch ( t1 )
		  {
		  case 1:
		     if ( t2 == 2 )
		     {
			yyval.val.u.v[0] = v1.u.s - v2.u.v[0];
			yyval.val.u.v[1] = v2.u.v[1];
			yyval.val.type   = t2;
		     }
		     else
			execerror( "unzulaessige Typkombination", NULL );

		     break;

		  default:
		     execerror( "unzulaessige Typkombination", NULL );
		  }
	       }
	    } break;
case 45:{
	       if ( yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  switch ( t = yyval.val.type = yypvt[-2].val.type )
		  {
		  case 1:
		     yyval.val.u.s = yypvt[-2].val.u.s * yypvt[-0].val.u.s;
		     break;

		  case 2:
		     Cmul( yypvt[-2].val.u.v, yypvt[-0].val.u.v, yyval.val.u.v );
		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
 		  }
	       }
	       else
	       {
		  Value v1, v2;
		  short t1, t2;

		  if ( yypvt[-2].val.type < yypvt[-0].val.type )
		  {
		     t1 = yypvt[-2].val.type;  t2 = yypvt[-0].val.type;
		     assval( &v1, t1, &yypvt[-2].val );
		     assval( &v2, t2, &yypvt[-0].val );
		  }
		  else
		  {
		     t1 = yypvt[-0].val.type;  t2 = yypvt[-2].val.type;
		     assval( &v1, t1, &yypvt[-0].val );
		     assval( &v2, t2, &yypvt[-2].val );
		  }

		  if ( t1 == 1 && t2 == 2 )
		  {
		     for ( i = 0; i < t2; i++ )
			yyval.val.u.v[i] = v1.u.s * v2.u.v[i];

		     yyval.val.type   = t2;
		  }
		  else
		     execerror( "unzulaessige Typkombination", NULL );
	       }
	    } break;
case 46:{
	       if ( yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  switch ( t = yyval.val.type = yypvt[-2].val.type )
		  {
		  case 1:
		     yyval.val.u.s = yypvt[-2].val.u.s / yypvt[-0].val.u.s;
		     break;

		  case 2:
		     if ( !Cdiv( yypvt[-2].val.u.v, yypvt[-0].val.u.v, yyval.val.u.v ))
			execerror( "Division durch 0", NULL );
		     break;

		  default:
		     execerror( "Operation unzulaessig", NULL );
 		  }
	       }
	       else if ( yypvt[-2].val.type == 1 && yypvt[-0].val.type == 2 ||
			 yypvt[-2].val.type == 2 && yypvt[-0].val.type == 1 )
	       {
		  Value v1, v2;

		  assval( &v1, 2, &yypvt[-2].val );
		  assval( &v2, 2, &yypvt[-0].val );

		  if ( yypvt[-2].val.type == 1 )
		     v1.u.v[1] = .0;
		  else
		     v2.u.v[1] = .0;

		  if ( !Cdiv( v1.u.v, v2.u.v, yyval.val.u.v ))
		     execerror( "Division durch 0", NULL );

		  yyval.val.type = 2;
	       }
	       else
		  execerror( "unzulaessige Typkombination", NULL );
	    } break;
case 47:{ 
	       yyval.val.type = 2;
	       Pow( &yyval.val, &yypvt[-2].val, &yypvt[-0].val );
	    } break;
case 48:{
	       if ( yypvt[-5].val.type == -1 )
		  if ( yypvt[-5].val.u.lv )
		     assval( &yyval.val, yypvt[-3].val.type, &yypvt[-3].val );
		  else
		     assval( &yyval.val, yypvt[-1].val.type, &yypvt[-1].val );
	       else
		  execerror( "kein logischer Ausdruck", NULL );
	    } break;
case 49:{
	       assval( &yyval.val, yypvt[-1].val.type, &yypvt[-1].val );
	    } break;
case 50:{
	       if ( yypvt[-2].val.type == 1 && yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  yyval.val.u.lv = ( yypvt[-2].val.u.s < yypvt[-0].val.u.s );
		  yyval.val.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    } break;
case 51:{
	       if ( yypvt[-2].val.type == 1 && yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  yyval.val.u.lv = ( yypvt[-2].val.u.s <= yypvt[-0].val.u.s );
		  yyval.val.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    } break;
case 52:{
	       if ( yypvt[-2].val.type == 1 && yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  yyval.val.u.lv = ( yypvt[-2].val.u.s > yypvt[-0].val.u.s );
		  yyval.val.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    } break;
case 53:{
	       if ( yypvt[-2].val.type == 1 && yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  yyval.val.u.lv = ( yypvt[-2].val.u.s >= yypvt[-0].val.u.s );
		  yyval.val.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    } break;
case 54:{
	       if ( yypvt[-2].val.type == 1 && yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  yyval.val.u.lv = ( yypvt[-2].val.u.s == yypvt[-0].val.u.s );
		  yyval.val.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    } break;
case 55:{
	       if ( yypvt[-2].val.type == 1 && yypvt[-2].val.type == yypvt[-0].val.type )
	       {
		  yyval.val.u.lv = ( yypvt[-2].val.u.s != yypvt[-0].val.u.s );
		  yyval.val.type = -1;
	       }
	       else
		  execerror( "logische Operationen nur fuer Skalare", NULL );
	    } break;
	}
	goto yystack;		/* reset registers in driver code */
}

# ifdef __RUNTIME_YYMAXDEPTH

static int allocate_stacks() {
	/* allocate the yys and yyv stacks */
	yys = (int *) malloc(yymaxdepth * sizeof(int));
	yyv = (YYSTYPE *) malloc(yymaxdepth * sizeof(YYSTYPE));

	if (yys==0 || yyv==0) {
	   yyerror( (nl_msg(30004,"unable to allocate space for yacc stacks")) );
	   return(1);
	   }
	else return(0);

}


static void free_stacks() {
	if (yys!=0) free((char *) yys);
	if (yyv!=0) free((char *) yyv);
}

# endif  /* defined(__RUNTIME_YYMAXDEPTH) */

